package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.OrgSector;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class OrgSector_Grid_Main2{
    private String orgsectorid;
    private String memo;
    private String porgsectorid;
    private String updateman;
    private String srfmajortext;


    private String srfdataaccaction;


    private String srfkey;


    private Integer validflag;
    private Integer virtualflag;
    private String orgcode;
    private String orgid;
    private String porgsectorname;
    private String reporgsectorid;
    private String orgname;
    private Integer ordervalue;
    private String levelcode;
    private String orgsectorname;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp updatedate;
    public  void fromOrgSector(OrgSector sourceEntity)  {
         this.setOrgsectorid(sourceEntity.getOrgsectorid());
         this.setMemo(sourceEntity.getMemo());
         this.setPorgsectorid(sourceEntity.getPorgsectorid());
         this.setUpdateman(sourceEntity.getUpdateman());
         this.setSrfmajortext(sourceEntity.getOrgsectorname());
         this.setSrfdataaccaction(sourceEntity.getOrgsectorid());
         this.setSrfkey(sourceEntity.getOrgsectorid());
         this.setValidflag(sourceEntity.getValidflag());
         this.setVirtualflag(sourceEntity.getVirtualflag());
         this.setOrgcode(sourceEntity.getOrgcode());
         this.setOrgid(sourceEntity.getOrgid());
         this.setPorgsectorname(sourceEntity.getPorgsectorname());
         this.setReporgsectorid(sourceEntity.getReporgsectorid());
         this.setOrgname(sourceEntity.getOrgname());
         this.setOrdervalue(sourceEntity.getOrdervalue());
         this.setLevelcode(sourceEntity.getLevelcode());
         this.setOrgsectorname(sourceEntity.getOrgsectorname());
         this.setUpdatedate(sourceEntity.getUpdatedate());
	}

	public static Page<OrgSector_Grid_Main2> fromOrgSector(Page<OrgSector> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<OrgSector_Grid_Main2> targetpage=new Page<OrgSector_Grid_Main2>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<OrgSector_Grid_Main2> records=new ArrayList<OrgSector_Grid_Main2>();
        for(OrgSector source:sourcePage.getRecords()) {
            OrgSector_Grid_Main2 target=new OrgSector_Grid_Main2();
            target.fromOrgSector(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("orgname","组织机构"); }});
        columnModelList.add(new HashMap(){ { put("porgsectorname","上级部门"); }});
        columnModelList.add(new HashMap(){ { put("orgsectorname","部门名称"); }});
        columnModelList.add(new HashMap(){ { put("orgcode","部门组织编号"); }});
        columnModelList.add(new HashMap(){ { put("validflag","启用标志"); }});
        columnModelList.add(new HashMap(){ { put("ordervalue","显示次序"); }});
        columnModelList.add(new HashMap(){ { put("levelcode","级别编码"); }});
        columnModelList.add(new HashMap(){ { put("virtualflag","虚拟部门"); }});
        columnModelList.add(new HashMap(){ { put("memo","备注"); }});
        columnModelList.add(new HashMap(){ { put("updateman","更新人"); }});
        columnModelList.add(new HashMap(){ { put("updatedate","更新时间"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<OrgSector> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(OrgSector source:searchResult.getRecords()) {
            OrgSector_Grid_Main2 target=new OrgSector_Grid_Main2();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<OrgSector> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}